(function($){
		  
	$.coverflow = function(t,p)
	{
		g={
			init:function(){
				if(!p)p={
					reflection:0         // Sets the height of the reflection in % of the source image 
					,focus:4               // Sets the numbers of images on each side of the focussed one
					,images_cursor:'pointer'  // Sets the cursor type for all images default is 'default'
					,slider_cursor : 'default'  // Sets the slider cursor type: try "e-resize" default is 'default'
					,xstep : 150
					,background: "none"
				};
				t.option=p;
				t.target=0;
				t.current=1000;
				t.timer=0;
				t.caption_id=0;
				t.new_slider_pos=0;
				t.index=0;
				
				
				$(t)
					.append('<div class="coverflowcontent" style="width:100%;height:100%;overflow:hidden;background:#000;"></div>')
					.css({width:'100%',height:'100%',overflow:'hidden',position:"absolute"});
				
				
				t.$body=$(".coverflowcontent",t);
				t.$caption=$(".coverflowcaption",t);
				t.$scrollbar=$(".coverflowscrollbar",t);
				t.$slider=$(".coverflowslider",t);
				$('img,iframe',t).appendTo(t.$body);
				t.$images=$('img,iframe',t);
				t.$images.each(function(){		this.ow=this.width;this.oh=this.height;this.proportion=this.ow/this.oh;	});
				t.max = t.$images.length;
				
				t.$images.reflect();
				t.$images=$('div',t.$body);
				
				
				g.flow();
				if(document.addEventListener){
					t.$body[0].addEventListener('DOMMouseScroll',function(event){g.wheel(event);},false);
				}
				t.$body[0].onmousewheel=function(event){g.wheel(event);};
				t.$images.click(function() { g.glideTo(this.x_pos, this.i); }).click();
				$(window).resize();
			},
			
			flow:function (){
				t.images_width = $(t).width();
				t.images_height = $(t).height();
				t.images_top = 0;
				t.images_left = 0;
				t.size = t.images_width * 0.5;
				t.max_height = t.images_width * 0.51;				
			
				$(t).height("100%");//t.max_height
				t.$body.css({height:"100%"});//t.images_width * 0.338 });
				
				
				for (var index = 0; index < t.max; index++)
				{ 
					var image = t.$images[index];					
					image.x_pos = (-index * t.option.xstep);
					image.i = index;
					image.h = Math.min(t.$body.height(),image.children[0].oh*2/3); 
					image.w = image.h*image.children[0].proportion;
					
					switch ((image.w + 1) > (image.h / (t.option.reflection + 1))) 
					{
						/* Landscape format */
						case true:
							image.pc = 118;
							break;
		
						/* Portrait and square format */
						default:
							image.pc = 100;
							break;
					}
					
					$(image).css({
						display:"block"
						,position:"absolute"
						,top:0
						,width:image.w
						,height:image.h
						,border:"none"
						,overflow:"visible"
						,cursor:t.option.images_cursor
					});
					$(image.children[0]).css({
						width:"100%"
						,height:"100%"
						,display:"block"
						,position:"absolute"
						,top:0
					});
					$(image.children[1]).css({
						width:"100%"
						,height:"50%"
						,display:"block"
						,position:"absolute"
						,top:"100%"
					});
			
				}
			},
			
			
			
			
			glideTo:function (x, index){
				if(t.images_width != $(t).width() || t.images_height != $(t).height()){
					g.flow();
					g.glideTo(x, index);
				}else{
					t.index=index;
					t.target = x;
					if (t.timer == 0)
					{
						window.setTimeout( function(){g.step()}, 50);
						t.timer = 1;
					}
				}
			},
			
			
			moveTo:function(x){
				t.current = x;
				var zIndex = t.max;				
				/* Main loop */
				for (var index = 0; index < t.max; index++)
				{
					
					var image = t.$images[index];
					var current_image = index * - t.option.xstep;
					if ((x < -(t.option.xstep*5.5)) || (x > (t.option.xstep*5.5)))
					{
						$(image).hide();
					}
					else 
					{
						var z = Math.sqrt(10000 + x * x) + 50; 
						var xs = x / z * t.size + t.size; 
						var new_img_h = (image.h / image.w * image.pc) / z * t.size;
						switch ( new_img_h > t.max_height )
						{
							case false:
								var new_img_w = image.pc / z * t.size;
								break;
			
							default:
								new_img_h = t.max_height;
								var new_img_w = image.w * new_img_h / image.h;
								break;
						}
						var new_img_top = (t.images_height*0.75 - new_img_h) * 0.5 + t.images_top; 
						image.style.left = (xs - (image.pc / 2) / z * t.size + t.images_left) + 'px';
						if(new_img_w && new_img_h)
						{ 
							image.style.height = new_img_h + 'px'; 
							image.style.width = new_img_w + 'px'; 
							image.style.top = new_img_top + 'px';
						};
						
						/* Set the image opacity */
						if ((x < -(t.option.xstep*4.5)) || (x > (t.option.xstep*4.5)))
						{
							if (x > 0)
								g.setOpacity(image, (t.option.xstep*5.5-x)/t.option.xstep);
							else
								g.setOpacity(image, (t.option.xstep*5.5+x)/t.option.xstep);
						}
						else
						{
							g.setOpacity(image, 1);
						}
						switch ( x < 0 )
						{
							case true:
								zIndex++;
								break;
			
							default:
								zIndex = zIndex - 1;
								break;
						}
						image.style.zIndex = zIndex; 
						$(image).show();
					}
					x += t.option.xstep;
				}
			},
			
			setOpacity:function (image, value){
				if (image.filters && image.filters[0])
				{
					image.filters[0].opacity = value * 100;
				}
				else
				{
					image.style.opacity = value;
				}
			},
			
			
			step:function (){
				switch (t.target < t.current-1 || t.target > t.current+1) 
				{
					case true:
						g.moveTo(t.current + (t.target-t.current)/3);
						window.setTimeout( function(){g.step()}, 50);
						t.timer = 1;
						break;
			
					default:
						t.timer = 0;
						break;
				}
			},
			
			
			
			wheel:function (event){
				var delta = 0;
				if (!event) event = window.event;
				if (event.wheelDelta)
				{
					delta = event.wheelDelta / 120;
				}
				else if (event.detail)
				{
					delta = -event.detail / 3;
				}
				if (event.preventDefault) event.preventDefault();
				event.returnValue = false;				
				if (delta) g.handle(delta);
			},
			
			
			handle:function (delta){
				switch (delta)
				{
					case 1:
						if(t.index>0){
							t.target = t.target + t.option.xstep;
							t.index=t.index-1;
						}
						break;
					case -1:
						if(t.index<t.max){
							t.target = t.target - t.option.xstep;
							t.index=t.index+1;
						}
						break;
				}
				g.glideTo(t.target, t.index);
			}
			
		};	
		
		g.init();		
		return g;
	};


	$.fn.coverflow = function(p) {
		return this.each( function() {
				$.coverflow(this,p);
			});

	}; 
		
})(jQuery);