﻿$(function(){	
	window.App="ImageViewer";
	window.path=getRequest("path");
	loadLang();
	layout();
	bindEvent(); 
	loadData();
});




function layout(){
	$('body').layout({ 
			center__paneSelector:"#main"
		,	north__paneSelector:"#top"  
		,	north__size:60
		,	north__spacing_open:0
		,	east__paneSelector:"#right"  
		,	east__size:185
		,	east__spacing_open:5
		,	contentSelector:".data"
	}); 
	$('#toolbar').toolbar();
	if(!window.top.Dean){
		var l=document.getElementsByTagName("link");
		for (i=0;i<l.length;i++){
			var h1=l[i].getAttribute("href");
			var h2=h1.replace('Default','Default/album');
			l[i].setAttribute("href",h2);
		}
	}
	if(!window.top.user||window.top.user===''){
		$('.ROTATEC, .ROTATECC').hide();
	}
}

function loadData(path){
	if(!path)path=window.win.fromWinObject; 
	if(window.slideInterval)window.clearInterval(window.slideInterval); 
	$("#list").empty();
	if($.browser.msie){
		$("#list").html('<ul class="iconlist">'+$(path).html()+'</ul>');
	}
	else{
		$(path).clone().appendTo($("#list"));
		$("#list ul:first")[0].className="iconlist";
	}
	$("#list li.dir, #list li.media, #list li.document").remove();

	
	$("#list li").click(function(){
		$("#list li.selected").removeClass('selected');
		$(this).addClass('selected');
		var img=new Image();
		img.className="slideimage webview";
		img.style.cssText="opacity:0;filter:alpha(opacity=0);";
		img.src=$(this).attr('webview')+'&_'+new Date().getTime();
		img.lowsrc=$(this).attr('thumbnail');
		img.onload=function(){img.ow=img.width;img.oh=img.height;img.portion=img.ow/img.oh};
		$("#pic").empty().append(img);
		$(img).animate({opacity: 1},500);
		if(!$("#top li.SLIDESHOW").hasClass('selected'))enableToolbar();
	});
	$("#list li.selected:first").click();
	try{$("#list")[0].scrollTop=$("#list li.selected:first")[0].offsetTop;}catch(e){};
	
}

function enableToolbar(){
	$("#top li.ROTATEC, #top li.ROTATECC, #top li.ZOOMOUT, #top li.ZOOMIN, #top li.SLIDESHOW, #top li.FULLVIEW").addClass('enabled');
	var p=$("#list li.selected").prev();
	var n=$("#list li.selected").next();
	if(p.length==0)$("#top li.BACK").removeClass('enabled');
	else $("#top li.BACK").addClass('enabled');
	if(n.length==0)$("#top li.FORWARD").removeClass('enabled');
	else $("#top li.FORWARD").addClass('enabled');
}

function bindEvent(){
	$("#top li.FULLVIEW").click(function(){
		if(!$(this).hasClass('enabled'))return;
		toView();
	});
	
	$("#top li.BACK").click(function(){
		if(!$(this).hasClass('enabled'))return;
		$("#list li.selected").prev().click();
	});
	
	
	$("#top li.FORWARD").click(function(){
		if(!$(this).hasClass('enabled'))return;
		$("#list li.selected").next().click();
	});
	
	
	
	$("#top li.ZOOMIN").click(function(){
		if(!$(this).hasClass('enabled'))return;
		toZoomIn();
	});
	
	$("#top li.ZOOMOUT").click(function(){
		if(!$(this).hasClass('enabled'))return;
		toZoomOut();
	});
	
	
	$("#top li.ROTATEC").click(function(){
		if(!$(this).hasClass('enabled'))return;
		rotateImage(-90);
		
	});
	
	$("#top li.ROTATECC").click(function(){
		if(!$(this).hasClass('enabled'))return;
		rotateImage(90);
	});
	
	
	$("#top li.SLIDESHOW").click(function(){
		$(this).toggleClass('selected');
		if($(this).hasClass('selected')){
			$("#top li").removeClass('enabled');
			window.slideInterval=window.setInterval(function(){slideShow();},6000);
		}
		else {
			window.clearInterval(window.slideInterval);
			$("#list li.selected").click();
		}
	});
}



function toZoomIn(){
		var $img=$("#pic img");
		var img=$img[0];
		if($img.hasClass('webview')){
			$('#waiting').show();
			img=new Image();
			
			img.onload=function(){
				$('#waiting').hide();
				$(img).width($img.width()).height($img.height());
				$(img).css({width:$img.width()*1.5, height:$img.height()*1.5});
				$('#pic').empty().append(img);	
				refreshImages();
			}
			img.src=$("#list li.selected").attr('path')+'?hash='+window.top.SessionID+'&login='+window.top.user+'&_='+new Date().getTime();
			img.className="slideimage";
		}else{
			$img.css({width:$img.width()*1.5, height:$img.height()*1.5});
		}
}

function toZoomOut(){
		var $img=$("#pic img");
		var img=$img[0];		
		var w=$img.width()/1.5;
		var h=$img.height()/1.5;
		if(w<10||h<10)return;
		$img.css({width:w, height:h});
}



function rotateImage(d){	
	var path=$("#list li.selected").attr('path');
	var c=(d===90)?90:-90;	
	$("#waiting").show();
	$.ajax({
	   url: path
	   ,type: "GET"
	   ,cache:false
	   ,data: {
		   hash:window.top.SessionID
		   ,rotate:c
		   ,nocontent:''
		}
	   ,cache: false
	   ,complete: function(XMLHttpRequest, textStatus){
			if(XMLHttpRequest.status===204||XMLHttpRequest.status===200||XMLHttpRequest.status===1223){		
				var img=new Image();	
				img.src=path+'?hash='+window.top.SessionID+'&login='+window.top.user+'&_='+new Date().getTime();
				img.className="slideimage";
				img.onload=function(){
					$("#waiting").hide();
					var $img=$("#pic img");
					$(img).width($img.height()).height($img.width());
					$('#pic').empty().append(img);
				}
				refreshImages();
			}			
			else{
				$("#waiting").hide();
				alert($.l10n.__('ImageViewer_alert_rotateerror'));
			}
		}		
		//,timeout: 10000
	 });

}



function refreshImages(path){
	var $li;
	if(path){
		$li=$("#list li[path="+path+"]");
	}
	else{
		$li=$("#list li.selected");
		path=$li.attr('path');
	}
	var thumbnail =	$li.attr('thumbnail');

	var img=new Image();
	img.src=thumbnail+'&_'+new Date().getTime();
	$("a div.img",$li).empty().append(img);
	window.top.$('li[path='+path+'] a div.img',window.win.fromWinObject).empty().append($(img).clone())
}


function slideShow(){
	var n=$("#list li.selected").next();
	if(n.length==0)n=$("#list li:first");
	n.click();
	$("#list")[0].scrollTop=n[0].offsetTop;
}

