﻿$(function(){
	window.App="MediaPlayer";
	var o=(window.win)?window.win.fromWinObject:null;
	var path=getRequest('path');
	var auto=getRequest('auto');
	auto=(auto=='false')?false:true;
	if(path&&path!=='')o={path:path, auto:auto}
	//if(window.top.MediaPlayer)window.top.MediaPlayer.player({path:path,type:type});
	window.playlistindex=0;
	window.playlistfolder=window.top.root+'home/Playlists/';
	createFolder();
	loadLang();
	loadData(o); 
});

function loadData(o){
	if(!o){
		return;
	}
	if(!o.path){
		return;
	}
	var path=o.path;
	
	if(typeof(path)==='object'){ 
		loadPaths(path);
		window.loop=false;
		return;
	}
	
	
	window.loop=true;
	play(o);
}


function play(o){
	var path=o.path;
	var auto=o.auto;
	path=path.split('?')[0];
	//path=path.replace('download=true','').replace('&download=','').replace('&quote=true','');
	var type=o.type; 
	try{
		if(window.playlistindex>0)	window.parent.$('#PLAYPREV').addClass('enabled');
		else window.parent.$('#PLAYPREV').removeClass('enabled');
		if(window.playlistindex<window.playlist.length-1)window.parent.$('#PLAYNEXT').addClass('enabled');
		else window.parent.$('#PLAYNEXT').removeClass('enabled');
	}catch(e){}
		
	var title=path.split('/');
	title=title[title.length-1];
	title=title.split('?');
	title=decodeURIComponent(title[0]);	
	try{if(window.win.app.options.id==="MediaPlayer")window.win.setTitle(title);}catch(e){}
	path=(path.indexOf('?')>-1)?path:path+'?session='+window.top.SessionID+'&login='+window.top.user;
	if (/\((iPhone|iPad|iPod)/i.test(navigator.userAgent)) {
		$('body').html('<embed id="media" autostart="true" autoplay="true" src="'+path+'"></embed>');
		return;
	}
	else{
		if(title.lastIndexOf('.')<0){
			ext="undefined";
		}
		else{
			ext=title.toLowerCase().split('.');
			ext=ext[ext.length-1];	
		}
		if(!type||type==='')type=ext;

		var quicktimes=['aif','aiff','aac','au','bmp','gsm','mov','mid','midi','mpg','mpeg','mp4','m4a','psd','qt','qtif','qif','qti','snd','tif','tiff','wav','3g2','3gp']
		var flashs=['flv','mp3','swf'];
		var mediaplayers=['avi','asx','asf','wma','wmv'];
		var realplayers=['ra','ram','rm','rpm','rv','smi','smil'];
		var realplayertypes=[ 'audio/x-pn-realaudio', 'audio/x-pn-realaudio', 'audio/x-pn-realaudio-plugin', 'audio/x-realaudio'];		
		var mediaplayertypes=['video/x-msvideo','audio/basic','audio/midi','audio/x-mpegurl', 'audio/x-wav', 'application/octet-stream'];
		var quicktimestypes=['video/mpeg','video/quicktime','audio/x-aiff'];
		var flashstypes=['audio/mpeg'];
		

		if($.inArray(ext,quicktimes)>-1||$.inArray(type,quicktimestypes)>-1){ 
			if(!hasPlugin('QuickTime'))return;
		}
		if($.inArray(ext,flashs)>-1||$.inArray(type,flashstypes)>-1){
			if(!hasPlugin('Shockwave Flash'))return;
		}
		if($.inArray(ext,mediaplayers)>-1||$.inArray(type,mediaplayertypes)>-1){
			if(!hasPlugin('Windows Media Player','MediaPlayer.MediaPlayer.1'))return;
		}
		if($.inArray(ext,realplayers)>-1||$.inArray(type,realplayertypes)>-1){
			if(!hasPlugin('RealPlayer','rmocx.RealPlayer G2 Control'))return;
		}

		$('body').empty().html('<a href="'+path+'" id="media"></a><div id="title">'+title+'</div>');
		
		$("#media").media({					  
				params:    { 
					//src:path
					width: "100%"				
					,height: "100%"
					,controls:"imagewindow,controlpanel"
					,center:false
					,maintainaspect:true
					,scale:"ASPECT"
					,nojava:true
					,showcontrols:true
					,bgcolor:"#000000"
					,kioskmode:true
					,autosize:false
					,displaysize:"4"
					,stretchtofit:true
					,allowfullscreen:true
					,allowscript:true
					,autostart:auto
					,autoplay:auto
					,enablejavascript:true
					,loop:((window.loop)?'true':'false')
					,postdomevents:'true'
					,flashvars:'autostart='+((auto)?'true':'false')+'&logo.hide=true'
			}
		});	
		window.setTimeout(function(){
			var player=document.getElementById('media').childNodes[0];
			qtListener(player, 'qt_ended', playnext, false);
			wmpListener(player, playnext );
			realListener(player, playnext);
		},500);	
	}
	$('#title').fadeOut(5000); 
	if(window.top.webdav&&window.top.SessionID){
		toSave(path);
	}
}

function playerReady(obj) {
	player = document.getElementById('media'); 
	player.addModelListener('STATE', 'flashListener');
};


function flashListener(obj){
	if (obj["newstate"] == "COMPLETED"){
         playnext();
     }  
}

function playnext(){
	window.playlistindex++;
	if(window.playlistindex<window.playlist.length){
		play({path:window.playlist[window.playlistindex]});
	}
	
}

function playprev(){
	window.playlistindex--; 
	if(window.playlistindex>-1){
		play({path:window.playlist[window.playlistindex]});
	}
}

function wmpListener(obj,  handler){
		window.wmpinterval=setInterval(function(){
			try{
				if(obj.playState==1){
					clearInterval(window.wmpinterval);
					handler.apply();
				}
			}catch(e){clearInterval(window.wmpinterval);}
		},500);			
}

function realListener(obj, handler){
		window.realinterval=setInterval(function(){
			try{
				if(obj.GetPlayState()==0){
					clearInterval(window.realinterval);
					handler.apply();
				}
			}catch(e){clearInterval(window.realinterval);}
		},500);	
}



function qtListener(obj, evt, handler, captures){
        if ( document.addEventListener )
            obj.addEventListener(evt, handler, captures);
        else
            obj.attachEvent('on' + evt, handler);
}


function loadPaths(path){
	window.playlist=[];
	window.playlistindex=0;
	for(var i=0, l=path.length;i<l;i++){ 
			window.playlist.push(path[i]);
	};
	var o={
		path:window.playlist[window.playlistindex]
		,type:''
	};
	play(o);
}





function toSave(item){
	var path=window.playlistfolder+'Recent.plist'; 
	$.ajax({
		   url: path
		   ,data:{session:window.top.SessionID, login:window.top.user}
		   ,type: "GET"
		   ,cache: false
		   ,dataType: "xml"
		   ,success: function(data){
				toAddItem(path,item,data);
			}
		   ,error: function(data) {
				toAddItem(path,item)
			}
	});
}



function toAddItem(path,item,data){
	var exsit=false;
	var p=item;
	p=p.split('?')[0];

	if(data){
		$('location',data).each(function(){
			if($(this).text()===p)exsit=true;
		});
		if(exsit)return;
	}	
	var t=p.split('/');
	t=t[t.length-1];
	var track=('<track><location>' + p + '</location><creator></creator><album></album><title>' + t + '</title><annotation></annotation><duration></duration><info></info></track>');
	if(data){
		$('tracklist',data).appendXml(track);
		var xml= xmlToString(data).replace(/\sxmlns=\"http:\/\/www\.w3\.org\/1999\/xhtml\"/g,'')
	}
	else{
		xml='<?xml version="1.0" encoding="UTF-8"?><playlist version="1" xmlns="http://xspf.org/ns/0/"><tracklist>'+track+'</tracklist></playlist>';
	}
	var options = {
            content:xml
            ,content_type:  'text/xml'                 
    };
	var handler = {
		onComplete: function(result){$("#waiting").hide();}
	}; 
	window.top.webdav.PUT(handler, path, options);
	
}


function createFolder(){
	try{window.top.webdav.MKCOL({}, window.playlistfolder, {}); }catch(e){}
}



function hasPlugin(plugin,activeX){
	if (!activeX) activeX = plugin + "." + plugin;
	var f=false,n=navigator;
	try{
		if (n.plugins && n.plugins.length){
			for (var ii=0;ii<n.plugins.length;ii++ ){
				if (n.plugins[ii].name.indexOf(plugin)!=-1){
					f=n.plugins[ii].description;
					break;
				}
			}
		}
		else if (window.ActiveXObject){
				if(plugin==='Shockwave Flash') f=new ActiveXObject("ShockwaveFlash.ShockwaveFlash.10");
				else f=new ActiveXObject(activeX); 
		}
	}catch(e){}
	if(!f){
		var a='';
		switch(plugin){
			case 'QuickTime':
				a='http://www.apple.com/quicktime/download/';
			break;
			case 'Shockwave Flash':
				a='http://www.adobe.com/go/getflashplayer';
			break;
			case 'Windows Media Player':
				a='http://www.microsoft.com/Windows/MediaPlayer/';
			break;
			case 'RealPlayer':
				a='http://www.real.com/player/';
			break;
		}
		a='<br/><a href="'+a+'" target="_blank">'+a+'</a>';
		$('body').html('');
		var div=document.createElement('div');
		$(div)
		.addClass('data')
		.html($.l10n.__('MediaPlayer_alert_noplugin').replace('{0}', '<b> '+plugin+' </b>'))
		.append(a)
		.appendTo($('body'));
	}
	return f;
}