﻿$(function(){
	window.App="Preference";
	loadLang();	
	loadData();
	bindEvent();
});



//-----------------------------------------------------------------------------------------------------------------------
function bindEvent(){	
	$("#APPLY").click(function(){	toApply();	});
}



function loadData(){	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/get/spindown/"
		,cache:false
		,data:{
			hash:window.top.SessionID
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			$("#timeout").val($('seconds',data).text()/60);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}



function toApply(){	
	if(!validate())return;
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/spindown/disk"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,timeout:$("#timeout").val()+"m"
			}
		,type: "POST"
		,dataType:"xml"
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}

function validate(){
	var fields = [
		{
			method : 'required',
			value : $('#timeout').val(), 
			element : $('#timeout')[0],
			param : null, 
			errParam : $.l10n.__("Preference_power_text_timeout")
		},
		{
			method : 'number',
			value : $('#timeout').val(), 
			element : $('#timeout')[0],
			param : null, 
			errParam :$.l10n.__("Preference_power_text_timeout")
		},
		{
			method : 'range',
			value : $('#timeout').val(), 
			element : $('#timeout')[0],
			param : [0,330], 
			errParam : [$.l10n.__("Preference_power_text_timeout"),0,330]
		}
	];

	return validateFields(fields);
}