﻿var HTML5UPLOAD={

init:function (){ 
	$('body').bind('drop', dragdrop);
	$('body').bind('dragover', dragover);
	$('body').bind('dragenter', dragenter);
	$('body').bind('dragleave', dragleave); 	

	HTML5UPLOAD.loaded=true;
	
	function dragover(event){
		//event.stopPropagation();
		//event.preventDefault();
		return false;
	}
	
	function dragenter(event){
		//event.preventDefault();	
		return false;
	}
	
	function dragleave(event){
		return false;
	}
	
	//拖拽进入后
	function dragdrop(event) {
		var url;
		var data = event.originalEvent.dataTransfer;
		if ($.browser.mozilla) {
			url=data.getData('text/uri-list');
			event.preventDefault();
			event.stopPropagation();
		}
		else{
			url=data.getData('URL');
			event.returnValue = false;
		}
		dragleave();
		
		if(url&&url.indexOf(window.location.protocol+"//"+window.location.host)==0)return;	
		
		
		if(!window.top.uploadproxy.path){
			if(window.top.MyNAS.mainWin){
				var c=window.top.MyNAS.mainWin.content;
				if(c.$UPLOAD.hasClass('enabled'))window.top.uploadproxy.path=c.$curTreeNode[0].path; 
				window.top.uploadproxy.force=false;
			}
		}

		if(window.top.uploadproxy.path)HTML5UPLOAD.addTasks(data.files, window.top.uploadproxy.path, window.top.uploadproxy.force);
		window.top.uploadproxy.path=null;
		window.top.uploadproxy.force=false;
		return false;
	}
	
	//this.showWindow();
	

},

showWindow:function(){
	if(!window.top.MyNAS)window.top.loadApp('MyNAS',function(){window.top.MyNAS.upload();});
	else window.top.MyNAS.upload();	
},


fileExsit:function(path){
	var list=$("#tasks tr");
	for(var i=0;i<list.length;i++){
		if($("td[_name='target'] div",list[i]).html()==path)return true;
	}
	return false;
},


serverFileExsit:function(file, path){	
	var option = {
				depth: "0"
				,operation: "allprop"
			};
	var handler = {
			onSuccess: function(result){
				if(window.top.checkAPIError(result))return;
				alert( $.l10n.__('MyNAS_upload_alert_fileatserver').replace('{0}',file.name));
			}
			,onError: function(result){ 
				if(result.status===404||result.status==='404'){
					new HTML5UPLOAD.uploadTask(file, path);
				}
				else{
					alert(  $.l10n.__('global_alert_systemerror').replace('{0}', ' status='+result.status ) );	
				}				
			}
		};
	window.top.webdav.PROPFIND(handler, (path+encodeURIComponent(file.name)), option);
},


addTasks:function(files, path, force){ 
	this.showWindow();
	for (var i = 0; i<files.length; i++) {
		var file=files[i];
		var pathname=path+file.name; 
		try{
			if(file.size>0){
				if(HTML5UPLOAD.fileExsit(pathname)){
					alert( $.l10n.__('MyNAS_upload_alert_fileatlist').replace('{0}',file.name));
					return;
				}
				if(force) {new HTML5UPLOAD.uploadTask(file, path);}
				else  {HTML5UPLOAD.serverFileExsit(file, path);}
			}else{
				alert($.l10n.__('MyNAS_upload_alert_filesize0').replace('{0}',file.name ));
			}
		}catch(e){};
	}	

	if(window.uploadtimer)window.clearInterval(window.uploadtimer);
	window.uploadtimer=window.setInterval(function(){
		if(window.top.$("#tasks tr.queuing").length===0){
			window.clearInterval(window.uploadtimer);
			if(window.top.MyNAS)window.top.MyNAS.refreshWin(path);
		}
		else{
			window.top.$("#tasks tr.queuing").each(function(){
				if(!this.task.time)this.task.time=0;
				this.task.time++; 
				$("div.time",this).html(formatTime(this.task.time));
			});
		}
	}
	,1000);
		
},


uploadTask:function(file,path){
	if(!$("#tasks")[0])return;
	
	this.initTask=function(){
		if(!window.taskID)window.taskID=0;
		window.taskID++;
		this.file=file;
		this.path=path;
		this.name=file.name;
		this.info={};
		this.length=file.size;	
		
		$("#tasks")[0].grid.addRow({
			id:'uploadtask'+window.taskID
			,operation:''
			,filename:this.name
			,progress:''
			,filesize:formatBytes(this.length)
			,uploaded:0
			,target:this.path+ this.name
			,time:'00:00:00:000'
			,speed:''
		});

		var tr=$("#tasks tr#uploadtask"+window.taskID);		
		
		var play=document.createElement("a");
			play.className="icon s12 play";
			play.style.cssText="padding:0;margin:0 5px;";
			play.task=this;	
			$(play).click(function(){
			   this.task.send();
			});
			this.$playButton=$(play);
		var remove=document.createElement("a");
			remove.className="icon s12 remove";
			remove.style.cssText="padding:0;margin:0 5px;";
			remove.task=this;		
		$("td[_name='operation'] div",tr).append(play).append(remove);
		$("td[_name='progress'] div",tr).html("<div class='progressbar' style='padding:0;margin:0;width:100%;'><div style='padding:0;margin:0;'></div><span>0%</span></div>");

		$(remove).click(function(){ this.task.remove();	});	
			
						
		
		
		this.$progressbar=$("td[_name='progress'] div.progressbar div",tr);
		this.$uploaded=$("td[_name='uploaded'] div",tr);
		this.$speed=$("td[_name='speed'] div",tr);
		this.$percentage=$("td[_name='progress'] span",tr);
		this.$time=$("td[_name='time'] div",tr);
		this.$time.addClass("time");
		this.$target=$("td[_name='target'] div",tr);
		this.$task=tr;
		this.$task.addClass("queuing");
		tr[0].task=this;
		if($("#tasks tr.running").length==0)this.send();
	}
	
	//上传
	this.send=function(){
		this.$playButton.remove();
		this.$task.addClass("running");
			
		var task=this;
		var request=new XMLHttpRequest();		
		this.request=request;
		

		this.request.upload.onprogress = function(progressEvent){
			var c=progressEvent.lengthComputable;
			if(c){
				var t=progressEvent.total;
				var l=progressEvent.loaded; 
				task.$uploaded.html(formatBytes(l));				
				var p=parseInt((l/t)*100)+"%";
				task.$percentage.html(p);
				task.$progressbar.css({width:p}); 
				//task.$speed.html(formatBytes(this.task.v)+'/s');			
			}
		};
		
		
		this.request.onreadystatechange = function(){				
				switch(request.readyState){
					case 4:    
						var apierror=false; 
						var status=request.status;
						
						if(status=='201'||status=='204'||status=='1223'||status=='200'||status=='412'){
							apierror=false;
							if(status=='412')alert(  $.l10n.__('global_alert_systemerror').replace('{0}', ' status='+status + ' wrong file format!') );		
							if(status=='200')apierror=window.top.checkAPIError(task.request.responseText);
						}
						else{
							apierror=true;
							alert(  $.l10n.__('global_alert_systemerror').replace('{0}', ' status='+status ) );	
						}

						task.$task.removeClass("running");	
						task.remove(); 
						task.next();
					break;
				}
			}; 
			
		request.open( "POST", task.path+task.name  +'?streaming='+(($.browser.msie)?'false':'true') ); 
		request.setRequestHeader('Session', window.top.SessionID);
		request.setRequestHeader('Content-Range', 'bytes 0-' + (task.length-1) + '/'+task.length);	
		request.send(task.file);		

	}
	

	
	
	
	//删除任务
	this.remove=function(){
		var bool=true;
		if(this.$task.hasClass("running")){
			if(!confirm($.l10n.__('MyNAS_upload_alert_notcomplete'))){
				bool=false;
			}
		}
		if(bool){
			this.$task.remove();
			this.request=null;
			this.send=function(){};
			if(this.request)this.request.abort();
		}
	}
	
	//继续任务
	this.next=function(){
		if($("#tasks tr.running")>0)return;
		try{$("#tasks tr.queuing")[0].task.$playButton.click();}catch(e){}
	}
	
	//初始化新任务
	this.initTask();
}

}