$(function(){
	window.App="Email";
	loadLang();
	bindEvent();
	getSender();
	loadData();	
	layout();
});

function layout(){	
	window.editor=new TINY.editor.edit('editor',{
		id:'editor',
		width:"100%",
		height:"100%",
		cssclass:'te',
		controlclass:'tecontrol',
		rowclass:'teheader',
		dividerclass:'tedivider',
		controls:['bold','italic','underline','strikethrough','|','subscript','superscript','|',
				  'orderedlist','unorderedlist','|','outdent','indent','|','leftalign',
				  'centeralign','rightalign','blockjustify','|','unformat','|','undo','redo','n',
				  'font','size','style','|','image','hr','link','unlink','|','cut','copy','paste','print'],
		fonts:['Verdana','Arial','Georgia','Trebuchet MS'],
		xhtml:true,
		bodyid:'editorbody',
		toggle:{text:'',activetext:'',cssclass:'toggle'}
	});
	$('body').layout({ 
			center__paneSelector:"#main"
		,	north__paneSelector:"#top"  
		,	north__size:100
		,	north__spacing_open:0
		,	south__paneSelector:"#bottom"  
		,	south__size:80
		,	south__spacing_open:0
		,	center__minWidth:400
		,	contentSelector:".data"
		,	center__onresize_end: function(){ patch(); }
	}); 
	patch();
}

function bindEvent(){
	$("#APPLY").click(function(){	toSend();	});
	$("#reveiver").click(function(){	window.top.System.addReceiver({fn:addReceiver,data:'email'});});
	$("#sender").change(function(){	setSender();	});
	
}
	
	
function loadData(o){
	var s='';
	var dl=window.top.location.protocol+"//"+window.top.NASinfo.registername+'.'+$.l10n.__('global_link_domainname');
	if(!o)o=window.win.fromWinObject;
	if(o){
		if(!o.path)o.path="";
		if(o.email)$("#address").val(o.email);
		for(var i=0;i<o.path.length;i++){
			var p=dl+o.path[i];
			if(p.indexOf('?')==-1){
				p=p+'?session='+window.top.SessionID+'&login='+window.top.user;
			}
			var n=p.split('/');
			n=n[n.length-1];
			n=n.split('?');
			n=n[0];
			try{n=decodeURIComponent(n)}catch(e){};
			s += '<a href="'+p+'" target="_blank"/>'+n+'</a><br/>';
		}
	}
	var album=dl+"album.html?author="+window.top.user;
	s += $.l10n.__("global_text_visitalbum")+" <br/><a href='"+album+"'>"+album+"</a>";
	$("#editor").val(s);
}


function addReceiver(r){ 
	var v=$("#address").val();
	$("#address").val(  v + ( (/,$/.test(v)||v==='')?'':',') + r.join(',') );
}



function toSend(){ 
	if(!toValidate())return;
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/send/email"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,subject:$("#subject").val()
			,body:window.editor.e.body.innerHTML
			,sender:$('#sender').val()
			,receiver:$("#address").val()
		}
		,type: "POST"
		,dataType:"xml"		
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			alert ( $.l10n.__("Email_alert_sendok") );
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
		
	});
}

function toValidate(){
	if($("#address").val()==""||$("#subject").val()==""){
		alert($.l10n.__("global_alert_inputerror"));
		return false;
	}
	return true;
}

function getSender(){
	$.ajax({
	   url: window.top.root+'home/.email.conf'
	   ,type: "GET"
	   ,cache:false
	   ,data: {
		   hash:window.top.SessionID
		}
	   ,cache: false
	   ,dataType: "xml"
	   ,success: function(data){
			$('#sender').val($('sender',data).text());
			if($('> configuration',data).length>0)$('#sender')[0].data=data;
		}
		,error:function(data){
			$('#sender').val(window.top.user);	
		}			
	   //,timeout: 10000
	 });
}

function setSender(){
	try{if(window.top.NASinfo.storage.writable==='no')return;}catch(e){}
	var path=window.top.root+'home/.email.conf';
	var data=$('#sender')[0].data; 
	if(!data){
		data='<?xml version="1.0" encoding="UTF-8"?><configuration><sender>'+$('#sender').val()+'</sender></configuration>';
	}else{
		$('sender',data).text($('#sender').val());
		data=xmlToString(data); 
	}
	var options = {
		content: data.replace(/\sxmlns=\"http:\/\/www\.w3\.org\/1999\/xhtml\"/g,'')
		,content_type:  'text/xml'                 
    };
	window.top.webdav.PUT({}, path, options);
}


function patch(){
	var h=$('div.te').height()-$('div.teheader').height()*2-4;
	$('div.te iframe').parent().height(h);
}