$(function(){
	window.App="SMS";	
	loadLang();
	layout();
	bindEvent();
	loadData();	
});

function layout(){	
	$('body').layout({ 
			center__paneSelector:"#main"
		,	north__paneSelector:"#top"  
		,	north__size:64
		,	north__spacing_open:0
		,	south__paneSelector:"#bottom"  
		,	south__size:80
		,	south__spacing_open:0
		,	center__minWidth:400
		,	contentSelector:".data"
		,	center__onresize_end: function(){ patch(); }
	}); 
}

function bindEvent(){
	$("#APPLY").click(function(){	toSend();	});
	$("#reveiver").click(function(){	window.top.System.addReceiver({fn:addReceiver,data:'phone'});});
	$('#address')[0].data=[];
}
	
	
function loadData(o){
	var s='';
	var dl=window.top.location.protocol+"//"+window.top.NASinfo.registername+'.'+$.l10n.__('global_link_domainname');
	if(!o)o=window.win.fromWinObject;
	if(o){
		if(!o.path)o.path="";
		if(o.email)$("#address").val(o.email);
		for(var i=0;i<o.path.length;i++){
			var p=dl+o.path[i];
			if(p.indexOf('?')==-1){
				p=p+'?session='+window.top.SessionID+'&login='+window.top.user;
			}
			var n=p.split('/');
			n=n[n.length-1];
			n=n.split('?');
			n=n[0];
			try{n=decodeURIComponent(n)}catch(e){};
			s += p+'\n';
		}
	}
	var album=dl+"album.html?author="+window.top.user;
	s += $.l10n.__("global_text_visitalbum")+"\n"+album;
	$("#editor").val(s);
}


function addReceiver(r){
	var v=$("#address").val();
	$("#address").val(  v + ( (/,$/.test(v)||v==='')?'':',') + r.join(',') );
}



function toSend(){ 
	if(!toValidate())return;
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/send/sms"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,msg:$('#editor').val()
			,dest:$("#address").val()
		}
		,type: "POST"
		,dataType:"xml"		
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			alert ( $.l10n.__("SMS_alert_sendok") );
		}
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
		//,timeout:20000
		
	});
}

function toValidate(){
	if($("#address").val()==""||$("#editor").val()==""){
		alert($.l10n.__("global_alert_inputerror"));
		return false;
	}
	return true;
}